import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;



public class MyAvrCommands {

	// public final static String commPortIdentifier = "/dev/tty.usbserial-FTF56DZT";
	// public final static String commPortIdentifier = "/dev/tty.usbserial-A100OXPZ";
	public final static String commPortIdentifier = "/dev/tty.SLAB_USBtoUART";
	
	public static void sendCommand(int command) throws Exception {
		Enumeration ports = CommPortIdentifier.getPortIdentifiers();
		System.out.println("Comm ports:");
		while (ports.hasMoreElements()) {
			CommPortIdentifier portId = (CommPortIdentifier) ports.nextElement();
			if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) {
				System.out.println("portId.getName() = " + portId.getName());
				if (commPortIdentifier.equals(portId.getName())) {
					SerialPort sp = (SerialPort) portId.open("MyAvrCommands", 2000);
					sp.setSerialPortParams(115200, // 76800, // 9600, 
							SerialPort.DATABITS_8, 
							SerialPort.STOPBITS_1, 
							SerialPort.PARITY_NONE);
					InputStream in = sp.getInputStream();
					OutputStream out = sp.getOutputStream();

					byte[] buf = new byte[8];
					buf[0] = (byte)0xE6;
					buf[1] = (byte)0xB5;
					buf[2] = (byte)0xBA;
					buf[3] = (byte)0xB9;
					buf[4] = (byte)0xB2;
					buf[5] = (byte)0xB3;
					buf[6] = (byte)0xA9;
					buf[7] = (byte)command;
					out.write(buf);
					out.flush();

					System.out.print("Response: ");
					int x = 0;
					while ((x = in.read()) != 13) {
						System.out.print((char)x);
					}
					System.out.println();

					out.close();
					in.close();
					sp.close();
				} 
			} 
		} 
	} 
	
	public static void main(String[] args) throws Exception {
		int command;
		// command = '3'; // 3V
		// command = '5'; // 5V
		// command = '^'; // return board nominal voltage '3' or '5' Volt
		// command = 'i'; // return the Status of the programmer
		// command = 't'; // return emulationtype AVR911 ('a') or STK500 ('s')
		// command = 'v'; // return version as string
		// command = '%'; // return powerOnBurn on ('w') or off ('W')
		command = '+'; // turn on board power supply
		// command = '-'; // turn off board power supply
		sendCommand(command);
	} 
	
}

/*
command Light    MK2    MK3    description
----------------------------------------------------------------

+        X       X       X     turn on board power supply

-        X       X       X     turn off board power supply

r        X       X       X     release reset on the attached board

i        X       X       X     return the Status of the programmer

I        -       -       x     return ProgMode

m        -       X       X     switch the programmer in myMode

p        -       X      (X)    switch the programmer in programming mode

d        -       X       X     switch the programmer in pass-through mode RS232

s        -       -       X     switch the programmer in STK500 mode

a        -       -       X     switch the programmer in AVR910 mode

q        -       X       X     switch the programmer in quiet mode

t        X       -       -     return emulationtype AVR911 ('a') or STK500 ('s')

v        X       X       X     return version as string
                               e.g. info ="2.03.1457"

C        -       X       X     turn on RescueClock

c        -       X       X     trun off RescueClock

R        X       -       -     reset programmer

B + xx   -       X       -     set baud rate; next Byte is UBRRL;
			       8MHz: 51=19200, 34=28800,25=38400, 16=57600, (12=76800), 8=115200

W        X       -       -     powerOnBurn off

w        X       -       -     powerOnBurn on

%        X       -       -     return powerOnBurn on ('w') or off ('W')

3        X       -       -     switch to 3V
   
5        X       -       -     switch to 5V

^        X       -       -      return board nominal voltage '3' or '5' Volt

R        -       -       x     write current mode and ProgMode to EEPROM 


confirmation from the programmer: ["÷"+infos]+"÷±"+code+"\r\n"
*/
